### DP make include file ###
# modify to configure at your wish the compilation of the DP code
# uncomment the sections referring to your system

# CC          C compiler command
# CFLAGS      C compiler flags
# CPP         C preprocessor
# CPPFLAGS    C/C++/Objective C preprocessor flags, e.g. -I<include dir> if
#             you have headers in a nonstandard directory <include dir>
# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries
#             in a nonstandard directory <lib dir>
# LIBS        libraries to pass to the linker, e.g. -l<library>
# FC          Fortran compiler command
# FCFLAGS     Fortran compiler flags
# LOADER      The loader, either CC or FC
# LOADOPTS    Loader options
#             since the main is in C, you can link using the C compiler and hence
#             indicate thank to LFOR indicate to link the Fortran libraries
#             or you can link using the Fortran compiler and then indicate that
#             the main is in C (-no-fotranmain) and link the C libraries (-lm)
# LFOR        Options to load Fortran library from CC Loader
# ARCH        The archiver
# ARCHFLAGS   and the flag(s) to use when building archive (library)
# RANLIB      If you system has no ranlib, set RANLIB = echo.

CC = gcc
CFLAGS = -O3
# FC = g95
FC = gfortran
FCFLAGS = -O3
FREEFORM = -ffree-form
LOADER = $(FC)
LOADOPTS = $(FCFLAGS)
ARCH     = ar
ARCHFLAGS= cr
RANLIB   = ranlib

### all internal libraries: BLAS LAPACK MFFT XC ETSF_IO and NETCDF ###
LIBS = -llapack -lblas -lmfft -lxc -lnetcdf
ILIBS = ilapack.o imfft.o ioetsf.o
LDFLAGS = -L../lib/
CPPFLAGS = -I../include/


### internal libraries: BLAS LAPACK XC ETSF_IO and NETCDF ### + external FFTW ###
# LIBS = -llapack -lblas -lfftw -lxc -lnetcdf
# ILIBS = ilapack.o ifftw.o ioetsf.o
# LDFLAGS = -L../lib/
# CPPFLAGS = -I../include/ -I/usr/local/include




### IMSL library ###
# LIBS = -limsl -lxc -lnetcdf
# ILIBS = iimsl.o ioetsf.o
# CPPFLAGS = -I../include/

### NAG library ###
# LIBS = -lasl -lxc -lnetcdf
# ILIBS = iasl.o ioetsf.o
# CPPFLAGS = -I../include/

### IBM AIX with ESSL library ###
# FC = xlf
# CC = xlc
# LOADER = xlf
# FCFLAGS = -O3 -qstrict -bmaxdata:600000000 -bmaxstack:600000000 -qmaxmem=-1
# FREEFORM = -qfree=f90
# LDFLAGS = $(FCFLAGS)
# LIBS = -lessl -lxc -lnetcdf
# ILIBS = iessl.o ioetsf.o
# CPPFLAGS = -I../include/

###  Compaq Dec with CXML library ### 
# compaq alpha osf1 True64
# PLEASE USE gmake ON Compaq True64
# FC = f90
# FCFLAGS = -fast -convert big_endian -fpe4 -automatic
# FREEFORM = -free
# LD = $(CC)
# LDFLAGS = -L/usr/local/lib
# since the main is in C, you can link using the C compiler and hence
# indicate thank to LFOR indicate to link the Fortran libraries
# or you can link using the Fortran compiler and then indicate that
# the main is in C (-no-fotranmain) and link the C libraries (-lm)
# LFOR = /usr/lib/libfor.a -lUfor -lFutil
# LFOR = -lm -lfor
# LIBS = -lcxml -lxc -lnetcdf
# ILIBS = icxml.o ioetsf.o
# CPPFLAGS = -I../include/

### NEC SX5 with ASL library ###
# FC = f90
# CC = cc
# FCFLAGS = -Cvopt -R5 -p -ftrace
# FCFLAGS = -Cvopt
# FCFLAGS don't use -Chopt on NEC could give bad results
# FREEFORM = -f4
# LDFLAGS = -Wl "-G large -Z 4G -h 32G_memlayout" # not any more usefull
# LOADER = $(FC)
# LIBS = -lasl -lxc -lnetcdf
# ILIBS = iasl.o ioetsf.o
# CPPFLAGS = -I../include/

### Silicon Graphics IRIX ###
# FC = f90
# FCFLAGS = -O3 -r10000 -mips4
# LDFLAGS = -L/usr/local/lib
# LFOR = -lfortran  -lffio -lftn -lm
# LIBS = -lscs



