! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile, CNRS.
! All rights reserved.
!
! DP code
! Linear Response TDDFT code in Frequency-Reciprocal space on a Plane Waves basis set.
! Calculate Dielectric Properties.

subroutine fftwfn(npwwfn,nb,nk,nr,wfg,wfr,igfft,nfft1,nfft1a,nfft2,nfft3)
  ! FFT wavefunctions from G-space in PW format to r-space in fft-formar
  implicit none
  integer npwwfn, nb, nk, nr
  integer nfft1, nfft1a, nfft2, nfft3
  complex wfg(npwwfn,nb,nk)
  complex wfr(nr,nb,nk)
  integer igfft(npwwfn)
  integer ig, ik, ib
  print *, 'FFT wavefunctions to real space'
  wfr(:,:,:) = 0.0
  do ik = 1, nk
    do ib = 1, nb
      ! fill FFT array from PW array
      do ig = 1, npwwfn
        wfr(igfft(ig),ib,ik) = wfg(ig,ib,ik)
      enddo
      ! take FFT to give wfn in real space
      call c3dfft(wfr(:,ib,ik),nfft1a,nfft2,nfft3,nfft1,nfft2,nfft3,1)
    enddo
  enddo
  print *, 'done'
  print *
  return
end
