subroutine makeT(p,nh,hd,rho_vck,den_vck,Tkernel)
 use dpdef
 implicit none
 type(dpparam) p
 integer nh
 complex (kind(0.0d0)) :: hd(nh,nh)
 complex (kind(0.0d0)) :: rho_vck(nh,p%npwmat)
 complex (kind(0.0d0)) :: den_vck(nh,p%nomega)
 complex (kind(0.0d0)) :: Tkernel(p%npwmat,p%npwmat,p%nomega)
 complex (kind(0.0d0)), allocatable :: rho_vckstar(:,:)
 complex (kind(0.0d0)), allocatable :: phit(:)
 complex (kind(0.0d0)), allocatable :: phitstar(:)
 complex (kind(0.0d0)), allocatable :: phitaux(:)
 complex (kind(0.0d0)), external :: zdotu
 integer io,ig,igp,istat

 allocate(rho_vckstar(nh,p%npwmat),stat=istat)
 if(istat.ne.0) stop 'phit not allocated'
 rho_vckstar(:,:)=conjg(rho_vck(:,:))
 
 allocate(phit(nh),stat=istat)
 if(istat.ne.0) stop 'phit not allocated'
 allocate(phitstar(nh),stat=istat)
 if(istat.ne.0) stop 'phitstar not allocated'
 allocate(phitaux(nh),stat=istat)
 if(istat.ne.0) stop 'phitaux not allocated'

 do io=1,p%nomega
   do igp=1,p%npwmat
     phitstar(:)=rho_vckstar(:,igp)*den_vck(:,io)
     call zgemv('N',nh,nh,(1.d0,0.d0),hd(:,:),nh,phitstar,1,(0.d0,0.d0),phitaux,1)
     do ig=1,p%npwmat
       phit(:)=rho_vck(:,ig)*den_vck(:,io)
       Tkernel(ig,igp,io) = - zdotu(nh,phit,1,phitaux,1)
     enddo
   enddo
 enddo 

 write(6,*) 'T kernel obtained'
 return
end




subroutine makeW(p,b1,b2,b3,gvec,ucvol,op,grottb,igfft,fftmesh,&
 kibz,kbz,ktab,ktabi,ktabo,ktabr,wfr,&
 nh,hd,transtab)
 use ggwdef
 use dpdef
 implicit none
 type(dpparam) p
 type(mesh) fftmesh
 real :: b1(3),b2(3),b3(3)
 integer :: gvec(3,p%ngw)
 integer nh
 complex (kind(0.0d0)) :: hd(nh,nh)
 integer :: transtab(p%nkbz,p%nbndv,p%nbndc)

      
 real ucvol

 real op(3,3,p%nopq)
      integer :: igfft(p%npwvec,5,5,5)
      integer grottb(p%npwvec,2,p%nop)
      real kibz(3,p%nkibz), kbz(3,p%nkbz)
      integer ktab(p%nkbz), ktabi(p%nkbz), ktabo(p%nkbz)
      integer :: ktabr(fftmesh%nr,p%nkbz)
      integer nqbzem1
 real, allocatable :: qbz(:,:), qpg(:,:), qbzpg(:), qibz(:,:)
 integer, allocatable :: qtab(:), qtabi(:), qtabo(:)
      complex wfr(fftmesh%nr,p%nbnds,p%nkibz)
      real KMK1(3)

      
      real Q0VOL, FAQ, RTW
      real fcc_const
      logical VCUT
      real rlcut

      complex http, hcttp
      complex, allocatable :: h(:)
      complex, allocatable :: hk(:,:,:,:,:)
      integer fform
      integer nomegaem1, nqibzem1, npweps, npwwfnem1,nbndsem1
      integer nqbzmax
      complex omegaem1(1)
 complex, allocatable :: epsm1q(:,:,:), Wibz(:,:,:)
 complex W(p%ngw,p%ngw), Wstar(p%ngw,p%ngw)
 complex Wstardiag(p%ngw)

      complex rhotwg1(p%ngw), rhotwg2(p%ngw)
      complex rhxtwg_v(p%ngw,p%nbnds,p%nbnds)
      complex rhxtwg_c(p%ngw,p%nbnds,p%nbnds)  
      complex rhxtwg_q(p%ngw,p%nbnds,p%nbnds,p%nkibz)
      complex ctccp(p%ngw)
      complex ctccpigp
      
      integer igfftg0(p%ngw)
      integer ktabrk(fftmesh%nr), ktabrkp(fftmesh%nr)
      real tenergy, tpenergy
      integer ig, igp, igr, igpr
      integer ir
      integer ik,ikibz,iik,ikp,ikpibz,iikp
      integer iopk,iopkp
      integer iq,iqbz,iqibz,iopq,iiq
      integer iqbz_0
      integer g0(3)
      integer it, itp
      integer iv, ivp, ic, icp, ivr, icr, ikbz
      integer irv, irc, irvp, ircp, irvps, ircps
      integer i, ib


      integer itemp
      complex ctemp
      logical ltemp
      integer istat
      real qpgtemp

      logical :: DEBUG = .false.
      logical, parameter :: TIMEREVERSAL = .false.
      logical :: RESO = .true.
      logical :: COUP = .true.
      logical HMEMO
      integer lastirec
      integer :: kstart = 1
      integer :: kcstart = 1
      integer sizeofcomplex

      complex, external :: pdtqrc
      integer, external :: lrec
      complex, external :: cdotu
      logical :: WDIAG=.true.
      

!-----------------------------------------------------------------------
      nh = p%nt
 
      sizeofcomplex = 2*lrec()     

!     Some constants  
      FAQ = 4*PI/(UCVOL*p%nkbz)
      RTW = (6.*PI**2/(UCVOL*p%nkbz))**(1./3.)
      Q0VOL = (8.0*PI**3) / (UCVOL*p%nkbz)
!     If q=0 and C=V then set up rho-twiddle(G=0) to reflect an
!     analytic integration of q**-2 over the volume element:
!     <q**-2> = 7.44 V**(-2/3)   (for fcc cell)
      fcc_const = SQRT(7.44*Q0VOL**(-2.0/3.0))

!     Average of (q+q')**-2 integration for head of Coulomb matrix 
!     INTRTW(QL) = (2*PI*RTW + PI*(RTW**2/QL-QL)*LOG((QL+RTW)/(QL-RTW)))
!    &              * (UCVOL*p%nkbz)/(2*PI)**3. * QL*QL


      it = 0
      do ikbz = 1, p%nkbz 
        do ivr = 1, p%nbndv
          do icr = 1, p%nbndc
              it = it + 1 
              transtab(ikbz,ivr,icr) = it
          enddo 
        enddo 
      enddo 
      if(it/=p%nt) stop 'internal error on transtab'







!-----------------------------------------------------------------------

 lastirec = (nh*nh + nh)/2

 print *, 'excitonic hamiltonian'
 inquire(file='in.exh',exist=ltemp)
 if(ltemp) then  ! if already exists
  open(55,file='in.exh',access='direct',recl=sizeofcomplex)
  read(55,rec=lastirec+1) itemp
  if(itemp == nh) then
   print *, 'reading resonant exciton hamiltonian from in.exh'
   read(55,rec=lastirec+2) kstart
   if(kstart < p%nkbz) then
     kstart = kstart + 1
     print *, 'starting from k ', kstart
   else
     print *, 'reading'
     do itp = 1, nh
       do it = 1, itp
         ir = it + itp * (itp - 1) / 2
         read(55,rec=ir) ctemp
         hd(it,itp) = ctemp
         hd(itp,it) = conjg(ctemp)
       enddo
       hd(itp,itp) = real(hd(itp,itp))
     enddo
     close(55)
     print *, 'read'
     return
   endif
  else
   print *, 'ERROR: wrong in.exh'
   stop 'wrong in.exh'
  endif
 else
   close(55)
   open(55,file='out.exh',access='direct',recl=sizeofcomplex)
   print *, 'resonant term'
   kstart = 1
 endif
      
!----------------------------------------------------------------------
!     make W
!----------------------------------------------------------------------

 call testem1('in.em1',6,nqibzem1,nomegaem1,npweps,npwwfnem1,nbndsem1,fform)
 allocate(qibz(3,nqibzem1))
 allocate(epsm1q(p%ngw,p%ngw,nqibzem1),stat=istat)
 nomegaem1=1
 call rdem1('in.em1',6,p%ngw,nqibzem1,nomegaem1,qibz,omegaem1,epsm1q)
 nqbzmax=nqibzem1*p%nopq*p%ninvq
 allocate(qbz(3,nqbzmax),qtab(nqbzmax),qtabo(nqbzmax),qtabi(nqbzmax))
 call identq(qibz,nqibzem1,nqbzmax,op,p%nopq,p%ninvq,qbz,qtab,qtabi,qtabo,nqbzem1)
 allocate(qpg(p%ngw,nqibzem1))
 call clcqpg(p%ngw,gvec,qibz,nqibzem1,b1,b2,b3,qpg)
 
 allocate(Wibz(p%ngw,p%ngw,nqibzem1),stat=istat)
        do iqibz = 1, nqibzem1
          do ig = 1, p%ngw
            do igp = 1, p%ngw
              Wibz(ig,igp,iqibz) = epsm1q(ig,igp,iqibz) / &
                                  (qpg(ig,iqibz) * qpg(igp,iqibz))
            enddo
          enddo
        enddo
 deallocate(epsm1q)

      inquire(file='cutoff',exist=VCUT)
      if(VCUT) then
        open(97,file='cutoff')
        read(97,*) rlcut
        close(97)
        write(*,'("cut-off on the coulombian interaction ",f6.2)') rlcut
        
        do iq = 1, nqibzem1
          qpg(1,iq) = sqrt(2.0)/rlcut
          do ig = 2, p%ngw
            qpgtemp = qpg(ig,iq)
            qpg(ig,iq) = qpgtemp * sqrt(1.0/(1.0-cos(qpgtemp*rlcut)))
          enddo
        enddo
      endif

      

      
!----------------------------------------------------------------------
!     calculate all matrix elements in IBZ for q=0 to save time
!----------------------------------------------------------------------

      print *, 'calculate all matrix elements for q=0'
      print *, 'memory size ', p%ngw*p%nbnds**2*p%nkibz, 'sizeof(complex)'
      print *
      
!     identify q == 0
      iqbz_0 = 0
      do iqbz = 1, nqbzem1
        if(all(abs(qbz(:,iqbz))<1.0e-3)) iqbz_0 = iqbz
      enddo
      if(iqbz_0 == 0) then
        print *, '**ERROR excheig 1: q=0 not found'
        stop 'excheig 1: q=0 not found'
      endif

      iqbz = iqbz_0
      iq = iqbz_0
      iqibz = qtab(iq) ; iopq = qtabo(iq) ; iiq = (3-qtabi(iq))/2

      rhxtwg_q(:,:,:,:) = 0.0

!     loop over all k-points in IBZ
      do ik = 1, p%nkibz
        ikibz = ik ; iik = 1 ; iopk = 1 

!       Loop over  band V
        do iv = 1, p%nbnds

!         Loop over band C 
          do ic = 1, p%nbnds

!           symmetry index for IBZ = 1 (in ktabr(:,1)
            call rho_tw_g(p%ngw,fftmesh%nr,fftmesh%nr,&
            fftmesh%nrr(1),fftmesh%nrr(1),fftmesh%nrr(2),fftmesh%nrr(3),&
     &                    igfft(:,3,3,3),wfr(:,iv,ik),1,ktabr(:,1),&
     &                    wfr(:,ic,ik),1,ktabr(:,1),rhotwg1)

!           If q=0 treat Exchange and Coulomb-term independently
            if(iv.LE.p%homo .AND. ic.LE.p%homo .OR.&
     &         iv.GT.p%homo .AND. ic.GT.p%homo) THEN

             if(iv .ne. ic) THEN
!              COULOMB term: C.ne.V: ignore them
               rhotwg1(1) = 0.0
             else
!              If q=0 and C=V then set up rho-twiddle(G=0) to reflect an
!              analytic integration of q**-2 over the volume element:
!              <q**-2> = 7.44 V**(-2/3)   (for fcc cell)
               rhotwg1(1) = fcc_const * qpg(1,iq)
               if(VCUT) rhotwg1(1) = 1.0
             endif

            else

              rhotwg1(1) = (0.,0.)
            endif

            rhxtwg_q(:,iv,ic,ik) = rhotwg1(:)

          enddo ! ic
        enddo ! iv
      enddo ! ik 

      call pclock(900)


!----------------------------------------------------------------------
!     try to allocate excitonic hamiltonian
!----------------------------------------------------------------------

      print *, 'try to allocate W_ttp'
      allocate(hk(p%nbndv,p%nbndc,p%nkbz,p%nbndv,p%nbndc),stat=istat)
      if(istat> 0) stop 'buy more memory'
      print *, 'memory size ', lastirec, ' sizeof(complex)'
      allocate(h(lastirec),stat=istat)
      if(istat > 0) then
        HMEMO = .false.
        print *, 'not enough memory, write h to disk'
      else
        HMEMO = .true.
        print *, 'allocated'
        kstart = 1
        kcstart = 1
        h(:) = (0.0,0.0)
      endif


!----------------------------------------------------------------------
!     resonant hamiltonian
!----------------------------------------------------------------------
 
      print *, 'calculate resonant W'

      print *, 'disk space ', lastirec, ' sizeof(complex)'
!     append the size of hamiltonian matrix to check
      write(55,rec=lastirec+1) nh
      

!-----------------------------------------------------------------------
!     coulomb term
!-----------------------------------------------------------------------
            
           
 if(WDIAG) then
   print *, 'W diagonal only'
 else
   print *, 'W full'
 endif
 print *
      

 do ik = kstart, p%nkbz        ! loop over k
   write(unit=6,fmt='(t3,"status:",i4,"/",i5," completed")',advance='no') ik-1, p%nkbz
       ikibz = ktab(ik)
       iik = (3-ktabi(ik))/2
       iopk = ktabo(ik)
       ktabrk(:) = ktabr(:,ik)
!      if(iik==2) cycle             ! time-reversal or not       

       do ikp = ik, p%nkbz           ! loop over kp
        ikpibz = ktab(ikp)
        iikp = (3-ktabi(ikp))/2
        iopkp = ktabo(ikp)
        ktabrkp(:) = ktabr(:,ikp)

!      Find q = K - KP - G0
       kmk1(:) = kbz(:,ik) - kbz(:,ikp)
 call findqg0(iq,g0,kmk1,nqbzem1,qbz)
       iqibz = qtab(iq) ; iopq = qtabo(iq) ; iiq = (3-qtabi(iq))/2
       igfftg0(1:p%ngw) = igfft(1:p%ngw,3+g0(1),3+g0(2),3+g0(3))

!      set up table of |q(BZ)+G|
!       do ig = 1, p%ngw
!         qbzpg(grottb(ig,iiq,iopq)) = qpg(ig,iqibz)
!       enddo

!      create W (omega=0)
       if(iiq == 1) then
         do ig = 1, p%ngw
           igr = grottb(ig,iiq,iopq)
           do igp = 1, p%ngw
             igpr = grottb(igp,iiq,iopq)
             W(igr,igpr) = Wibz(ig,igp,iqibz)
           enddo
         enddo
       else
         do ig = 1, p%ngw
           igr = grottb(ig,iiq,iopq)
           do igp = 1, p%ngw
             igpr = grottb(igp,iiq,iopq)
             W(igr,igpr) = conjg(Wibz(ig,igp,iqibz))
           enddo
         enddo
       endif
       Wstar(:,:) = conjg(W(:,:))
       do ig = 1, p%ngw
         Wstardiag(ig) = Wstar(ig,ig)
       enddo

!      calculate matrix-elements rhxtwg_v and rhxtwg_c
       if(ik == ikp) then

        if(iik == 1) then
         do iv = p%lomo, p%homo         !      loop over band V
          do ivp = p%lomo, p%homo       !       Loop over band VP
           do ig = 1, p%ngw
            rhxtwg_v(grottb(ig,iik,iopk),ivp,iv) = rhxtwg_q(ig,ivp,iv,ikibz)
           enddo
          enddo
         enddo
         do icp = p%lumo, p%nbnds     !      Loop over band C_prime
          do ic = p%lumo,  p%nbnds    !       Loop over band C
           do ig = 1, p%ngw
            rhxtwg_c(grottb(ig,iik,iopk),icp,ic) = rhxtwg_q(ig,icp,ic,ikibz)
           enddo
          enddo
         enddo
        else
         do iv = p%lomo, p%homo         !      loop over band V
          do ivp = p%lomo, p%homo       !       Loop over band VP
           do ig = 1, p%ngw
            rhxtwg_v(grottb(ig,iik,iopk),ivp,iv) = conjg(rhxtwg_q(ig,ivp,iv,ikibz))
           enddo
          enddo
         enddo
         do icp = p%lumo, p%nbnds     !      Loop over band C_prime
          do ic = p%lumo,  p%nbnds    !       Loop over band C
           do ig = 1, p%ngw
            rhxtwg_c(grottb(ig,iik,iopk),icp,ic) = conjg(rhxtwg_q(ig,icp,ic,ikibz))
           enddo
          enddo
         enddo
        endif

       else ! ik /= ikp
       
        do iv = p%lomo, p%homo         !      loop over band V
         do ivp = p%lomo, p%homo       !       Loop over band VP
            call rho_tw_g(p%ngw,fftmesh%nr,fftmesh%nr,&
            fftmesh%nrr(1),fftmesh%nrr(1),fftmesh%nrr(2),fftmesh%nrr(3),&
     &                    igfftg0,&
     &                    wfr(:,ivp,ikpibz),iikp,ktabrkp,&
     &                    wfr(:,iv,ikibz),iik,ktabrk,&
     &                    rhxtwg_v(:,ivp,iv))
         enddo ! ivp
        enddo ! iv

        do icp = p%lumo, p%nbnds     !      Loop over band C_prime
         do ic = p%lumo,  p%nbnds    !       Loop over band C
            call rho_tw_g(p%ngw,fftmesh%nr,fftmesh%nr,&
            fftmesh%nrr(1),fftmesh%nrr(1),fftmesh%nrr(2),fftmesh%nrr(3),&
     &                    igfftg0,&
     &                    wfr(:,icp,ikpibz),iikp,ktabrkp,&
     &                    wfr(:,ic,ikibz),iik,ktabrk,&
     &                    rhxtwg_c(:,icp,ic))
         enddo ! ic
        enddo ! icp

       endif ! ik == ikp

       
!      now calculate:
!      sum_G,G' rhotw(G)* W(G,G') rhotw(G')
       do ic = p%lumo, p%nbnds
        irc = ic - p%lumo + 1
        do icp = p%lumo,  p%nbnds
         ircp = icp - p%lumo + 1

!        sum_GG' rho_c'c*(G) W(G,G') rho_v'v(G')
!        first sum on G: sum_G rho_c'c(G) W*(G,G')    (W conjgated)
         if(WDIAG) then
           ctccp(:) = rhxtwg_c(:,icp,ic) * Wstardiag(:)
         else
           ctccp(:) = matmul(rhxtwg_c(:,icp,ic),Wstar(:,:))
         endif
         
         do iv = p%lomo, p%homo
          irv = iv - p%lomo + 1
          
          
          do ivp = p%lomo, p%homo
            irvp = ivp - p%lomo + 1


!           then sum on G': sum_G' (rho_c'c(G) W*(G,G'))* rho_v'v(G')
            http = -faq * dot_product(ctccp(:),rhxtwg_v(:,ivp,iv))
            hk(irv,irc,ikp,irvp,ircp) = http
                          
          enddo ! ivp
         enddo ! iv
        enddo ! icp
       enddo ! ic
       
      enddo ! ikp
      
!      now store hamiltonian in memory or disc
       do ikp = ik, p%nkbz           ! loop over kp
       if(HMEMO) then
         do irc = 1, p%nbndc
           do ircp = 1, p%nbndc
        do irv = 1, p%nbndv
          it = transtab(ik,irv,irc)
          do irvp = 1, p%nbndv
            itp = transtab(ikp,irvp,ircp)
            hd(it,itp)=hk(irv,irc,ikp,irvp,ircp)
            hd(itp,it)=conjg(hk(irv,irc,ikp,irvp,ircp))
            if(itp >= it) then
             ir = it + itp * (itp - 1) / 2
             h(ir) = hk(irv,irc,ikp,irvp,ircp)
            else
             ir = itp + it * (it - 1) / 2
             h(ir) = conjg(hk(irv,irc,ikp,irvp,ircp))
            endif
           enddo
          enddo
         enddo
        enddo
       else
        do irvp = 1, p%nbndv
         do ircp = 1, p%nbndc
          itp = transtab(ikp,irvp,ircp)
          do irv = 1, p%nbndv
           do irc = 1, p%nbndc
            it = transtab(ik,irv,irc)
            if(itp >= it) then
             ir = it + itp * (itp - 1) / 2
             write(55,rec=ir) hk(irv,irc,ikp,irvp,ircp)
            else
             ir = itp + it * (it - 1) / 2
             write(55,rec=ir) conjg(hk(irv,irc,ikp,irvp,ircp))
            endif
           enddo
          enddo
         enddo
        enddo 
       endif
       enddo ! ikp
       
      if(.not. HMEMO) then
        write(55,rec=lastirec+2) ik
      endif


      enddo ! ik

      print *
      print *, 'coulomb term completed'
      print *
      if(HMEMO) then
        write(*,'(" -W(1,1) = [eV] ",f7.2)') real(h(1))*HARTREE
        print *
      endif
      
      
      call pclock(3000)

      
 
      deallocate(hk)
!----------------------------------------------------------------------
!     write hamiltonian 
!----------------------------------------------------------------------

      if(HMEMO) then
        print *, 'write resonant excitonic hamiltonian on disk'
        do ir = 1, lastirec
          write(55,rec=ir) h(ir)
        enddo
        write(55,rec=lastirec+1) nh
        write(55,rec=lastirec+2) p%nkbz
      endif
      
      close(55)
      
end



subroutine remove_diagonal(nh,hd,Wd)
 use ggwdef
 use dpdef
 implicit none
 integer nh
 complex (kind(0.0d0)) :: hd(nh,nh)
 real (kind(0.0d0)) :: Wd
 integer it
 real (kind(0.0d0)) :: rt, msd
 
 rt=0
 do it=1,nh
   rt=rt+hd(it,it)
 enddo
 Wd=rt/nh
 print *, 'removing diagonal from W by a value of [eV] ',Wd*HARTREE
 rt=0
 do it=1,nh
   rt=rt+(hd(it,it)-Wd)*(hd(it,it)-Wd)
 enddo
 msd=sqrt(real(rt))
 if(msd>0.05*HARTREE) then
   print *, 'warning: the diagonal of W is not constant'
   print *, 'taking average value'
 endif
   
 do it=1, nh
   hd(it,it) = 0
 enddo
 
 return
 end
