! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile, CNRS.
! All rights reserved.
!
! DP code
! Linear Response TDDFT code in Frequency-Reciprocal space on a Plane Waves basis set.
! Calculate Dielectric Properties.

! itcmlib: interface toward TCMLIB for matrix inversion
!          uses new tcmlib routines for lower store requirements

      subroutine cginv(n,a,lda)
      ! invert a complex matrix
      implicit none
      integer n, lda
      complex a(lda,n)
      complex wk(n)
      integer nt(n)
      real, parameter :: emach = 1.0e-6
      
      call cgelim(a,nt,lda,n,emach)
      call cmatin(a,nt,lda,n,wk)
      return
      end


      subroutine rginv(n,a,lda)
      ! invert a real matrix
      implicit none
      integer n, lda
      real a(lda,n)
      real wk(n)
      integer nt(n)
      real, parameter :: emach = 1.0e-6
      
      call gelim(a,nt,lda,n,emach)
      call matinv(a,nt,lda,n,wk)
      return
      end
